searchData={"items":[{"type":"module","title":"Magus.AgentChain","doc":"","ref":"Magus.AgentChain.html"},{"type":"function","title":"Magus.AgentChain.__struct__/0","doc":"Define a chain for agents.\n\nThis is an extention of the LangChain.Chains.LLMChain chain that provides\na few helpers for the agent use case.\n\nA `stream_handler` can be passed in when the AgentChain is created and then\nused automatically when the chain is run. This is useful for the AgentExecutor\nto listen to tokens as they're returned by the LLM.\n\nThe AgentChain can also be configured with a JSON schema that is used when\nrequesting content from the LLM and then used to validate that the LLM response\nconforms to the schema.","ref":"Magus.AgentChain.html#__struct__/0"},{"type":"function","title":"Magus.AgentChain.add_message/2","doc":"","ref":"Magus.AgentChain.html#add_message/2"},{"type":"function","title":"Magus.AgentChain.add_messages/2","doc":"","ref":"Magus.AgentChain.html#add_messages/2"},{"type":"function","title":"Magus.AgentChain.add_tool/2","doc":"","ref":"Magus.AgentChain.html#add_tool/2"},{"type":"function","title":"Magus.AgentChain.ask_for_json_response/2","doc":"Adds a JSON schema to the chain as the response format from the LLM.\n\nA message is added to the chain that tells the LLM to return the response\ncontent in JSON format. In the OpenAI case, the request will be made\nin [JSON Mode](https://platform.openai.com/docs/guides/text-generation/json-mode)","ref":"Magus.AgentChain.html#ask_for_json_response/2"},{"type":"function","title":"Magus.AgentChain.get_default_gemini_llm/0","doc":"","ref":"Magus.AgentChain.html#get_default_gemini_llm/0"},{"type":"function","title":"Magus.AgentChain.new!/1","doc":"Start a new AgentChain configuration.","ref":"Magus.AgentChain.html#new!/1"},{"type":"function","title":"Options - Magus.AgentChain.new!/1","doc":"- `:verbose` - Runs the LLM in verbose mode if set to true. Defaults to `false`.\n- `:stream_handler` - Handler that is called as the LLM returns messages.","ref":"Magus.AgentChain.html#new!/1-options"},{"type":"function","title":"Magus.AgentChain.run/1","doc":"Run the AgentChain.\n\nIf a `stream_handler` was specified when the AgentChain was created,\nit will be called as the LLM returns tokens.\n\nIf a JSON response was requested with `ask_for_json_response`, the response\nwill be validated against the schema and decoded to a struct.","ref":"Magus.AgentChain.html#run/1"},{"type":"type","title":"Magus.AgentChain.t/0","doc":"","ref":"Magus.AgentChain.html#t:t/0"},{"type":"module","title":"Magus.AgentExecutor","doc":"","ref":"Magus.AgentExecutor.html"},{"type":"function","title":"Magus.AgentExecutor.child_spec/1","doc":"The AgentExecutor is a GenServer for executing an agent and managing/storing its\nstate. This includes agent state as well as state about the execution (current node, status, errors, etc)\n\nFor each node in the agent graph, a new `Task` will be started to run the function for the current node.\nIf the node function succeeds, the current agent state will be updated and the executor\ntraverses the agent's graph to find the next node to execute.\nIf the node function fails, it is retrieved 3 times with an expotential backoff.\n\nOnce created, the AgentExecutor process can be subscribed to in order to get to state and log updates.","ref":"Magus.AgentExecutor.html#child_spec/1"},{"type":"function","title":"Magus.AgentExecutor.get_agent_log_topic/1","doc":"","ref":"Magus.AgentExecutor.html#get_agent_log_topic/1"},{"type":"function","title":"Magus.AgentExecutor.get_agent_state_topic/1","doc":"","ref":"Magus.AgentExecutor.html#get_agent_state_topic/1"},{"type":"function","title":"Magus.AgentExecutor.get_state/1","doc":"Returns the execution state of the given AgentExecutor process","ref":"Magus.AgentExecutor.html#get_state/1"},{"type":"function","title":"Magus.AgentExecutor.new/1","doc":"Create a new AgentExecutor process responsible for running an agent.","ref":"Magus.AgentExecutor.html#new/1"},{"type":"function","title":"Options - Magus.AgentExecutor.new/1","doc":"- `:agent` - The `Magus.GraphAgent` definition of the agent for the executor.\n- `:id` - A string to use for the id of the execution.","ref":"Magus.AgentExecutor.html#new/1-options"},{"type":"function","title":"Magus.AgentExecutor.notify_with_log/2","doc":"","ref":"Magus.AgentExecutor.html#notify_with_log/2"},{"type":"function","title":"Magus.AgentExecutor.run/1","doc":"Starts the agent execution for the given AgentExecutor process.","ref":"Magus.AgentExecutor.html#run/1"},{"type":"function","title":"Magus.AgentExecutor.subscribe_to_logs/1","doc":"Subscribe to logs coming from the agent execution. This includes info about steps and\nthe streamed content from the LLM.","ref":"Magus.AgentExecutor.html#subscribe_to_logs/1"},{"type":"function","title":"Magus.AgentExecutor.subscribe_to_new_agents/0","doc":"Subscribe to new agents being started.","ref":"Magus.AgentExecutor.html#subscribe_to_new_agents/0"},{"type":"function","title":"Magus.AgentExecutor.subscribe_to_state/1","doc":"Subscribe to agent execution state changes.","ref":"Magus.AgentExecutor.html#subscribe_to_state/1"},{"type":"type","title":"Magus.AgentExecutor.t/0","doc":"","ref":"Magus.AgentExecutor.html#t:t/0"},{"type":"module","title":"Magus.AgentExecutor.Step","doc":"","ref":"Magus.AgentExecutor.Step.html"},{"type":"module","title":"Magus.AgentExecutorLite","doc":"","ref":"Magus.AgentExecutorLite.html"},{"type":"function","title":"Magus.AgentExecutorLite.run/1","doc":"","ref":"Magus.AgentExecutorLite.html#run/1"},{"type":"module","title":"Magus.GraphAgent","doc":"","ref":"Magus.GraphAgent.html"},{"type":"function","title":"Magus.GraphAgent.add_conditional_edges/4","doc":"","ref":"Magus.GraphAgent.html#add_conditional_edges/4"},{"type":"function","title":"Magus.GraphAgent.add_edge/3","doc":"","ref":"Magus.GraphAgent.html#add_edge/3"},{"type":"function","title":"Magus.GraphAgent.add_node/3","doc":"","ref":"Magus.GraphAgent.html#add_node/3"},{"type":"function","title":"Magus.GraphAgent.cleanup/2","doc":"","ref":"Magus.GraphAgent.html#cleanup/2"},{"type":"function","title":"Magus.GraphAgent.get_final_output/2","doc":"","ref":"Magus.GraphAgent.html#get_final_output/2"},{"type":"function","title":"Magus.GraphAgent.set_entry_point/2","doc":"","ref":"Magus.GraphAgent.html#set_entry_point/2"},{"type":"type","title":"Magus.GraphAgent.node_name/0","doc":"","ref":"Magus.GraphAgent.html#t:node_name/0"},{"type":"type","title":"Magus.GraphAgent.t/0","doc":"","ref":"Magus.GraphAgent.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}